{ **************************************************************
  Datei: DPMI_ASM.PAS
  --------------------------------------------------------------
  Autor: Sven Letzel
  Datum: 09.04.1993
  Funktion: Demonstriert die Emulation eines Real-Mode-Interrupts
            sowie die Verwendung von Adressen unter DPMI
  Borland Pascal 7.0 - Zielplattform: Protected
  **************************************************************}

PROGRAM DPMI_ASM;

USES Crt, Dos, WinAPI;

TYPE
  tRegs = RECORD
  { * Registerstruktur fr Real-Mode-Interrupt *}
    EDI, ESI, EBP, Res,
    EBX, EDX, ECX, EAX: LONGINT;
    Flags, ES, DS, FS, GS,
    IP, CS, SP, SS: WORD;
  END;

VAR
  RP: tRegs;

FUNCTION GetCharPtr: POINTER; ASSEMBLER;
{ *************************************************************
  Diese Funktion ermittelt einen Zeiger auf den 8x16 ROM-BIOS-
  Zeichensatz
  *************************************************************}
ASM
   MOV AX, 300H
   {* Funktionsnummer $300: Simuliere Real-Mode-Interrupt *}
   MOV BX, 10H
   {* aufzurufender Interrupt: Video-BIOS: $10 *}
   MOV CX, 0
   MOV DX, Seg RP
   MOV ES, DX
   MOV DI, Offset RP
   {* Registerstruktur mu nach ES:DI *}
   MOV WORD Ptr tRegs[ES:DI].EAX, 1130H
   {* Int $10, Funktion: $11, Unterfunktion: $30 *}
   MOV WORD Ptr tRegs[ES:DI].EBX, 0600H
   {* Register BH = 06 *}
   INT 31H
   {* DPMI-Server bemhen *}
   MOV DX, tRegs[ES:DI].&ES
   {* ES(-Real-Mode)-Segment nach DX, und anschlieend mit
      EBP auf 24-Bit-Adresse umrechnen *}
   SHR DX, 4
   OR  DL, DL
   JC  @1
   MOV AH, DL
@1:
   SHR DX, 8
   XOR AL, AL
   ADD AX, WORD Ptr tRegs[ES:DI].EBP
   PUSH AX
   PUSH DX
   PUSH 0000
   CALL WinAPI.AllocSelector
   {* einen Selektor anfordern *}
   POP DX
   POP BX
   PUSH AX
   PUSH DX
   PUSH BX
   CALL WinAPI.SetSelectorbase
   {* Basisadresse mit Hilfe der berechneten 24-Bit-Adresse
      setzen *}
   PUSH AX
   PUSH AX
   PUSH 0000
   PUSH 256 SHL 4
   CALL WinAPI.SetSelectorLimit
   {* Segmentlnge auf Lnge des 8x16-Zeichensatzes setzen *}
   POP DX
   {* Selektor zurckgeben in DX *}
   XOR AX, AX
   {* Offset ist immer Null *}
END;

PROCEDURE PutStr(S: STRING; P: POINTER);
{************************************************************
 Diese Prozedur gibt einen String in Grobuchstaben aus, ihr
 wird auerdem ein Zeiger auf den Zeichensatz bergeben, der
 mit der Funktion GETCHARPTR bestimmt wird
 ************************************************************}
TYPE
  Chars = ARRAY[0..255, 0..15] OF BYTE;
VAR
  X: ^Chars;
  i, j, k: BYTE;
BEGIN
  X := P;
  FOR i:=2 TO 13 DO
  { ** Normalerweise for i:=0 to 15, sind bei verwendetem
    Zeichensatz und Buchstaben Null ** }
  BEGIN
    FOR j:=1 TO Length(S) DO
      FOR k:=7 DOWNTO 0 DO
        IF X^[Ord(S[j]),i] AND (1 SHL k) = (1 SHL k) THEN
        Write(#1) ELSE Write(' ');
    WriteLn;
  END;
END;

VAR
  r: Registers; P: POINTER;
BEGIN
  r.AX := $1686;
  {** $1686 ist Kennung fr DPMI **}
  Intr($2F, r);
  IF r.AX <> 0 THEN
  BEGIN
    WriteLn('Kein DPMI.');
    Halt;
  END;
  P := GetCharPtr;
  PutStr('Protected', P); PutStr('  Mode',P);
END.
