{$A+,B-,D-,E-,F-,G-,I-,L-,N-,O-,R-,S-,V-,X-,M 16384,0,0}
{$IFDEF Ver70}{$P-,Q-,T-}{$ENDIF}
(*===================================================================*)
(*                           KILLDISK.PAS                            *)
(*         Compiler: Turbo/Borland Pascal Real Mode Target           *)
(*                Copyright (C) 1993 te-wi Verlag                    *)
(*===================================================================*)
(* Beschreibung:                                                     *)
(*    Das Programm lscht einen Datentrger komplett und macht ihn   *)
(*    unbrauchbar. Der Datentrger mu anschlieend neu formatiert   *)
(*    werden. Alle Daten sind verloren!                              *)
(*===================================================================*)

PROGRAM KillDisk;

USES
  Dos, Upper, DOSUtil;

VAR
  TotalSectors      : LONGINT;
  Heads             : BYTE;
  Sectors           : WORD;
  Tracks            : WORD;
  Buffer            : ARRAY[1..512] OF BYTE;
  KillBuffer        : ARRAY[0..511] OF BYTE;
  BootBlock         : tBootBlock ABSOLUTE Buffer;
  Drive             : BYTE;
  answer            : STRING;
  Parameter         : ComStr;
  h, t, s           : WORD;
  i                 : INTEGER;
  counter           : WORD;
  st                : ARRAY[0..3] OF CHAR;

BEGIN
  IF ParamCount < 1 THEN
  BEGIN
    WriteLn('Kill Disk v 1.0');
    WriteLn('Aufruf: KillDisk Laufwerksbuchstabe (A..Z)');
    Halt;
  END;
  Parameter := UpString(ParamStr(1));
  Drive := Ord(Parameter[1]) - Ord('A') + 1;
  IF (NOT Drive IN [1..24]) THEN Halt;
  WriteLn(^M^J'Kill Disk Version 1.0');
  WriteLn('Das Programm zerstrt den Datentrger in Laufwerk ',
           Chr(Drive + 64) + ':');
  Write('Wollen Sie Kill Disk wirklich ausfhren? (J/N) ');
  ReadLn(answer);
  IF (Pos('j', answer) > 0) OR (Pos('J', answer) > 0) THEN
  BEGIN
   WriteLn;
   Write('Sind Sie sich ganz sicher? (J/N) ');
   ReadLn(answer);
   IF (Pos('j', answer) > 0) OR (Pos('J', answer) > 0) THEN {}
   ELSE
     Halt(1);
  END ELSE Halt(1);

{ Wer mehrere Disketten in einem Rutsch lschen will, sollte ab hier  }
{ eine entsprechende Abfrageschleife (siehe Diskcopy u. Format ein-   }
{ bauen.                                                              }

  i := ReadBootSector(Drive, Buffer);
  IF i <> 0 THEN
  BEGIN
    WriteLn('Der Datentrger ist nicht lesbar !!!');
    WriteLn('Kill Disk wird abgebrochen.');
    Halt;
  END;
  CASE BootBlock.Data.MediaDescriptor OF
    $F8: BEGIN { Festplatte mit variablen Werten }
          Heads            := BootBlock.Data.Heads;
          Sectors          := BootBlock.Data.SectorsPerTrack;
          IF BootBlock.Data.TotalSectors = 0 THEN
            TotalSectors   := BootBlock.Data.BigTotalSectors
          ELSE
            TotalSectors   := BootBlock.Data.TotalSectors;
         END;
    $F0,       { zwei Seiten 80 Spuren 18 oder 36 Sektoren HD    }
    $F9,       { zwei Seiten 80 Spuren  9 oder 15 Sektoren DD+HD }
    $FA,       { eine Seite  80 Spuren  8 Sektoren         DD SS }
    $FB,       { zwei Seiten 80 Spuren  8 Sektoren         DD DS }
    $FC,       { eine Seite  40 Spuren  9 Sektoren         DD SS }
    $FD,       { zwei Seiten 40 Spuren  9 Sektoren         DD DS }
    $FE,       { eine Seite  40 Spuren  8 Sektoren         DD SS }
    $FF: BEGIN { zwei Seiten 40 Spuren  8 Sektoren         DD DS }
           TotalSectors    := BootBlock.Data.TotalSectors;
           Heads           := BootBlock.Data.Heads;
           Sectors         := BootBlock.Data.SectorsPerTrack;
         END;
    ELSE WriteLn('Unbekanntes Medium!'^M^J +
                 'Kill Disk wird abgebrochen');
         Halt;
  END;
  
  Tracks  := TotalSectors DIV Sectors DIV Heads;
  FOR i := 0 TO 511 DO KillBuffer[i] := 0;
  st := 'tewi';
  FOR i := 0 TO 511 DIV 6 DO
  BEGIN
    t := i * 6;
    Move(st, KillBuffer[t], 6);
  END;
  counter := 1;
  FOR t := Pred(Tracks) DOWNTO 0 DO BEGIN
    FOR s := Sectors DOWNTO 1 DO BEGIN
      FOR h := Pred(Heads) DOWNTO 0 DO BEGIN
        i := DiskWrite(Drive, h, t, s, 1, KillBuffer);
        IF i <> 0 THEN
        BEGIN
          WriteLn(^h^h^h^h^h'Fehler beim Schreiben auf Laufwerk ',
          Chr(Drive + 64), ': Kopf: ', h, ', Spur ', t, ' Sektor ', s);
        END;
      END;
    END;
    Write(^h^h^h^h^h, counter);
    Inc(counter);
  END;
  WriteLn(#13#10'Disketteninhalt ist gelscht.');
END.

(*===================================================================*)
