{$A+,B-,D-,E-,F+,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V-,X+}
{$M 16384,0,655360}
PROGRAM Transfer;

{ Beispielprogramm zur Benutzung der Unit ParData. Das Programm
  transportiert Dateien  la xcopy auf den fremden Rechner. Die
  Bedienung ist schlicht gehalten. Auf dem Zielrechner mu das
  Programm mit "transfer /r" gestartet werden, auf dem Ursprungs-
  rechner mit "transfer Pfad".
  Sobald beide Programme gestartet sind, wird der Verzeichnisbaum
  komplett bertragen.                                            }

USES
  ParData, Crt, Dos;

TYPE
  DataType  = (Datei, Verzeichnis, EndVerzeich, Ende);
  DateiRec  = RECORD
                n   : STRING[12];
                dt  : LONGINT;
                atr : WORD;
                sz  : LONGINT;
              END;
  VerzRec   = RECORD
                n   : STRING[12];
              END;
  DataBlock = RECORD
                CASE t : DataType OF
                  Datei       : (d : DateiRec);
                  Verzeichnis : (v : VerzRec);
                  EndVerzeich : ();
                  Ende        : ();
              END;


VAR
  Block : ARRAY [0..8191] OF BYTE;
  BData : DataBlock ABSOLUTE Block;

PROCEDURE ReceiveData;
{ empfngt die Daten und setzt sie um. }
VAR
  tx   : DataType;
  Name : STRING[13];
  Time : LONGINT;
  Attr : WORD;
  fsz  : LONGINT;
  o    : BYTE;
  f    : FILE;
BEGIN
  REPEAT
    ReceiveBlock(BData,SizeOf(BData));
    tx := BData.t;
    CASE tx OF
      Datei       : BEGIN
                      Name := BData.d.n;
                      Time := BData.d.dt;
                      Attr := BData.d.atr;
                      fsz  := BData.d.sz;
                      Assign(f,Name);
                      ReWrite(f,1);
                      WHILE fsz > SizeOf(Block) DO BEGIN
                        ReceiveBlock(Block,SizeOf(Block));
                        BlockWrite(f,Block,SizeOf(Block));
                        Dec(fsz,SizeOf(Block));
                        Write('.');
                      END;
                      IF fsz <> 0 THEN BEGIN
                        ReceiveBlock(Block,fsz);
                        BlockWrite(f,Block,fsz);
                        Write('.');
                      END;
                      SetFTime(f,Time);
                      Close(f);
                      SetFAttr(f,Attr);
                    END;
      Verzeichnis : BEGIN
                      Name := BData.v.n;
                      {$I-} MkDir(Name); IF IOResult<> 0 THEN; {$I+}
                      ChDir(Name);
                    END;
      EndVerzeich : BEGIN
                      ChDir('..');
                    END;
    END;
  UNTIL tx = Ende;
END; { ReceiveData }

PROCEDURE SendData(ins : BYTE);
VAR
  SearchR : SearchRec;
  fsz     : LONGINT;
  f       : FILE;
BEGIN
  {$I-}
  FindFirst('*.*',Anyfile,SearchR);
  WHILE (SearchR.Attr AND VolumeID <> 0) AND (DosError = 0) DO
    FindNext(SearchR);
  WHILE (DosError = 0) DO BEGIN
    IF (SearchR.Attr AND Directory) <> 0 THEN BEGIN
      IF SearchR.Name[1] <> '.' THEN BEGIN
        WriteLn; Write('':ins,SearchR.Name);
        BData.t   := Verzeichnis;
        BData.v.n := SearchR.Name;
        SendBlock(BData,SizeOf(BData));
        ChDir(SearchR.Name);
        SendData(ins+2);
        BData.t   := EndVerzeich;
        SendBlock(BData,SizeOf(BData));
        ChDir('..');
      END;
    END ELSE BEGIN
      WITH SearchR DO
        fsz        := SearchR.Size;
        BData.t    := Datei;
        BData.d.n  := SearchR.Name;
        BData.d.dt := SearchR.Time;
        BData.d.atr:= SearchR.Attr;
        BData.d.sz := SearchR.Size;
        SendBlock(BData,SizeOf(BData));
        Assign(f,SearchR.Name);
        Reset(f,1);
        WHILE fsz > SizeOf(Block) DO BEGIN
          BlockRead(f,Block,SizeOf(Block));
          Dec(fsz,SizeOf(Block));
          SendBlock(Block,SizeOf(Block));
          Write('.');
        END;
        IF fsz <> 0 THEN BEGIN
          BlockRead(f,Block,fsz);
          SendBlock(Block,fsz);
        END;
        Close(f);
        Write('.');
    END;
    REPEAT
      FindNext(SearchR);
    UNTIL (SearchR.Attr AND VolumeID = 0) OR (DosError <> 0)
  END;
  {$I+}
END;

PROCEDURE WriteUsage;
BEGIN
  WriteLn('Aufruf des Programmes mit "transfer /r" zum empfangen und');
  WriteLn('"transfer <pfad>" zum Senden von Dateibumen.');
  Halt;
END;

FUNCTION UpStr(st : STRING) : STRING;
VAR
  i : INTEGER;
BEGIN
  FOR i := 0 TO Length(st) DO st[i] := UpCase(st[i]);
  UpStr := st;
END;

VAR c : BYTE;

BEGIN
  UnitInit(1);
  IF (ParamCount < 1) OR (ParamCount > 3) THEN
    WriteUsage;

  WriteLn;
  Write('Aufbau der Verbindung ...');
  WHILE CheckOther = SNotThere DO BEGIN
    Write('.'); Delay(1000);
  END;
  Delay(2000);
  WriteLn;

  IF UpStr(ParamStr(1)) = '/R' THEN BEGIN
    WriteLn('Empfangsmodus  ');
    WHILE (CheckOther <> SWantSend) DO BEGIN
      c := (c+1) MOD 10; Write(c,^H);
    END;
    StartReceive;
    ReceiveData;
    StopReceive;
  END ELSE BEGIN
    ChDir(ParamStr(1));
    WriteLn('SendeModus');
    StartSend;
    SendData(2);
    BData.t := Ende;
    SendBlock(BData,SizeOf(BData));
    StopSend;
    WriteLn('beendet');
  END;
END.
