PROGRAM TimerGDI;

USES WinTypes, WinProcs, WObjects, Strings;

TYPE
  pReeWindow = ^tReeWindow;
  tReeWindow = OBJECT (tWindow)
    PROCEDURE wmTimer (VAR Msg: tMessage); VIRTUAL wm_First + wm_Timer;
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE Destroy; VIRTUAL;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  TimerApp: tMyApplication;

PROCEDURE tReeWindow.SetupWindow;
BEGIN
  tWindow.SetupWindow;
  SetTimer (hWindow, 1, 50, NIL);
END;

PROCEDURE tReeWindow.Destroy;
BEGIN
  tWindow.Destroy;
  KillTimer (hWindow, 1);
END;

PROCEDURE tReeWindow.wmTimer (VAR Msg: tMessage);
VAR
  EinDC: hDC;
  R: tRect;
  NewPen: hPen;
BEGIN
  EinDC := GetDC (hWindow);
  GetClientRect (hWindow, R);
  MoveTo (EinDC, Random(R.Right), Random(R.Bottom));
  NewPen := CreatePen (ps_Solid, Random(20), RGB(Random(255), Random(255), Random(255)));
  SelectObject (EinDC, NewPen);
  LineTo (EinDC, Random(R.Right), Random(R.Bottom));
  ReleaseDC (hWindow, EinDC);
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New(pReeWindow, Init(NIL,'TimerGDI'));
END;

BEGIN
  TimerApp.Init ('TimerGDI');
  TimerApp.Run;
  TimerApp.Done;
END.
