PROGRAM BitDlg;

{$R BitDlg}

USES OWindows, ODialogs, WinTypes, WinProcs;

CONST
  { Command ID }
  idm_About = 100;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE Paint (PaintDC: hDC; VAR PaintInfo: tPaintStruct); VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + idm_About;
  END;

  pMyDialog = ^tMyDialog;
  tMyDialog = OBJECT (tDialog)
    PROCEDURE wmPaint (VAR Msg: tMessage); VIRTUAL wm_First + wm_Paint;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  GenericApp: tMyApplication;

CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.Menu := LoadMenu(hInstance, 'MyMenu');
  Attr.w := 640;
  Attr.h := 480;
END;

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: pMyDialog;
BEGIN
  MessageBeep(0);
  Dialog := New(pMyDialog, Init(@Self, 'AboutBox'));
  Application^.ExecDialog(Dialog);
END;

PROCEDURE tMyWindow.Paint (PaintDC: hDC; VAR PaintInfo: tPaintStruct);
VAR
  OldBitmap, NewBitmap: hBitmap;
  Bitmap: tBitmap;
  MemDC: hDC;
BEGIN
  NewBitmap := LoadBitmap (hInstance, 'blaise');
  MemDC := CreateCompatibleDC (PaintDC);
  OldBitmap := SelectObject (MemDC, NewBitmap);
  GetObject (NewBitmap, SizeOf(tBitmap), @Bitmap);
  BitBlt (PaintDC, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight, MemDC, 0, 0, SrcCopy);
  BitBlt (PaintDC, Bitmap.bmWidth, Bitmap.bmHeight, Bitmap.bmWidth*2, Bitmap.bmHeight*2, MemDC, 0, 0, SrcCopy);
  DeleteDC (MemDC);
END;

PROCEDURE tMyDialog.wmPaint (VAR Msg: tMessage);
VAR
  OldBitmap, NewBitmap: hBitmap;
  Bitmap: tBitmap;
  DialDC, MemDC: hDC;
  Rect: tRect;
BEGIN
  NewBitmap := LoadBitmap (hInstance, 'blaise');
  DialDC := GetDC (hWindow);
  MemDC := CreateCompatibleDC (DialDC);
  GetClientRect (hWindow, Rect);
  OldBitmap := SelectObject (MemDC, NewBitmap);
  GetObject (NewBitmap, SizeOf(tBitmap), @Bitmap);
  BitBlt (DialDC, 30, 20, Bitmap.bmWidth, Bitmap.bmHeight, MemDC, 0, 0, SrcCopy);
  DeleteDC (MemDC);
  Msg.Result := 0;
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'MyProgram'));
END;

BEGIN
  GenericApp.Init ('AProgram');
  GenericApp.Run;
  GenericApp.Done;
END.
