PROGRAM BmpClient;

{$R BmpClien}

USES OWindows, ODialogs, WinTypes, WinProcs;

CONST
  { Command ID }
  idm_About = 100;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + idm_About;
    PROCEDURE Paint (PaintDC: hDC; VAR PaintInfo: tPaintStruct); VIRTUAL;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  Attr.Menu := LoadMenu(hInstance, 'Generic');
  Attr.w := 380;
  Attr.h := 300;
END;

PROCEDURE tMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, 'MYICON');
END;

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: pDialog;
  DC, MemDC: hDC;
  OldBitmap, NewBitmap: hBitmap;
  Bitmap: tBitmap;
BEGIN
  Dialog := New(pDialog, Init(@Self, 'AboutBox'));
  DC := GetDC (Dialog^.hWindow);
  MemDC := CreateCompatibleDC (DC);
  OldBitmap := SelectObject(MemDC, NewBitmap);
  GetObject (NewBitmap, SizeOf(tBitmap), @Bitmap);
  BitBlt (DC, 10, 10, Bitmap.bmWidth, Bitmap.bmHeight, MemDC, 0, 0, SrcCopy);
  DeleteDC (MemDC);
  Application^.ExecDialog (Dialog);
  ReleaseDC (DC, Dialog^.hWindow);
END;

PROCEDURE tMyWindow.Paint (PaintDC: hDC; VAR PaintInfo: tPaintStruct);
VAR
  OldBitmap, NewBitmap: hBitmap;
  Bitmap: tBitmap;
  MemDC: hDC;
BEGIN
  NewBitmap := LoadBitmap (hInstance, 'blaise');
  MemDC := CreateCompatibleDC (PaintDC);
  OldBitmap := SelectObject (MemDC, NewBitmap);
  GetObject (NewBitmap, SizeOf(tBitmap), @Bitmap);
  BitBlt (PaintDC, 0, 0, Bitmap.bmWidth, Bitmap.bmHeight,
              MemDC, 0, 0, SrcCopy);
  BitBlt (PaintDC, Bitmap.bmWidth, 0, Bitmap.bmWidth*2, Bitmap.bmHeight,
              MemDC, 0, 0, SrcCopy);
  DeleteDC (MemDC);
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'Anzeigen einer Bitmap aus der Ressource'));
END;

VAR
  GenericApp: tMyApplication;

BEGIN
  GenericApp.Init ('GenericApp');
  GenericApp.Run;
  GenericApp.Done;
END.
