PROGRAM RevIcon;

{$R RevIcons}

USES WinDos, WObjects, WinTypes, WinProcs, Strings;

CONST
  { Command ID }
  idm_About = 100;
  idm_ChangeIcon = 101;

TYPE
  pMyWindow = ^tMyWindow;
  tMyWindow = OBJECT (tWindow)
    IconID: INTEGER;
    CONSTRUCTOR Init (aParent: pWindowsObject; aTitle: pChar);
    PROCEDURE SetupWindow; VIRTUAL;
    PROCEDURE GetWindowClass (VAR aWndClass: tWndClass); VIRTUAL;
    PROCEDURE About (VAR Msg: tMessage); VIRTUAL cm_First + idm_About;
    PROCEDURE ChangeIcon (VAR Msg: tMessage); VIRTUAL cm_First + idm_ChangeIcon;
    PROCEDURE wmSysCommand (VAR Msg: tMessage); VIRTUAL wm_First + wm_SysCommand;
  END;

  tMyApplication = OBJECT (tApplication)
    PROCEDURE InitMainWindow; VIRTUAL;
  END;

VAR
  GenericApp: tMyApplication;


CONSTRUCTOR tMyWindow.Init (aParent: pWindowsObject; aTitle: pChar);
BEGIN
  tWindow.Init (aParent, aTitle);
  IconID := 0;
  Attr.Menu := LoadMenu(hInstance, 'RevIcons');
END;

PROCEDURE tMyWindow.SetupWindow;
BEGIN
  tWindow.SetupWindow;
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_Separator, 0, NIL);
  AppendMenu (GetSystemMenu (hWindow, FALSE), mf_String, idm_ChangeIcon, 'Change Icon');
END;

PROCEDURE tMyWindow.GetWindowClass (VAR aWndClass: tWndClass);
BEGIN
  tWindow.GetWindowClass (aWndClass);
  aWndClass.hIcon := LoadIcon (hInstance, 'ICON_2');
END;

PROCEDURE tMyWindow.About (VAR Msg: tMessage);
VAR Dialog: pDialog;
BEGIN
  Dialog := New(pDialog, Init(@Self, 'AboutBox'));
  Application^.ExecDialog (Dialog);
END;

PROCEDURE tMyWindow.ChangeIcon (VAR Msg: tMessage);
VAR
  NewIcon: hIcon;
  Rect: tRect;
BEGIN
  CASE (IconID MOD 3) OF
    0: NewIcon := LoadIcon (hInstance, 'ICON_1');
    1: NewIcon := LoadIcon (hInstance, 'ICON_3');
    2: NewIcon := LoadIcon (hInstance, 'ICON_4');
  END;
  Inc(IconID);
  SetClassWord (hWindow, gcw_HIcon, NewIcon);
  GetClientRect (hWindow, Rect);
  InvalidateRect (hWindow, @Rect, TRUE);
END;

PROCEDURE tMyWindow.wmSysCommand (VAR Msg: tMessage);
BEGIN
  CASE Msg.wParam OF
    idm_ChangeIcon: ChangeIcon (Msg);
    ELSE DefWndProc (Msg);
  END;
END;

PROCEDURE tMyApplication.InitMainWindow;
BEGIN
  MainWindow := New (pMyWindow, Init(NIL, 'Changing Icons'));
END;

BEGIN
  GenericApp.Init ('ChangeIcons');
  GenericApp.Run;
  GenericApp.Done;
END.
