PROGRAM ShowIcon;
(* This is a demo program about how to iconize programs *)

USES WinTypes, WinProcs;

CONST
  AppName = 'Die vordefinierten Icons';

FUNCTION WindowProc(Window: hWND; Message, wParam: WORD;
  lParam: LONGINT): LONGINT; EXPORT; FORWARD;

CONST
  WindowClass: tWndClass = (
    Style: cs_HRedraw OR cs_VRedraw; (* class style identifier         *)
    lpfnWndProc: @WindowProc;     (* Address of window proc            *)
    cbClsExtra: 0;                (* reserve space in class structure  *)
    cbWndExtra: 0;		  (* reserve space in window structure *)
    hInstance: 0;
    hIcon: 0;
    hCursor: 0;
    hbrBackground: 0;
    lpszMenuName: AppName;
    lpszClassName: AppName);      (* name of window class	       *)

FUNCTION WindowProc(Window: hWND; Message, wParam: WORD;
  lParam: LONGINT): LONGINT;
VAR
  MyHDC: hDC;
  PaintStruct: tPaintStruct;
  Rect: tRect;
  MyIcon: hIcon;
BEGIN
  WindowProc := 0;
  CASE Message OF
    wm_Command: ;
    wm_Paint: BEGIN
	MyHDC := BeginPaint(Window, PaintStruct);
        GetClientRect (Window, Rect);
        Rect.Left := 5;
        Rect.Top := 50;

	DrawText(MyHDC, 'Application, Asterisk, Exclamation, Hand, Question', -1, Rect, dt_SingleLine);
        MyIcon := LoadIcon (0, idi_Application);
        DrawIcon (MyHDC, 30, 10, MyIcon);
        MyIcon := LoadIcon (0, idi_Asterisk);
        DrawIcon (MyHDC, 95, 10, MyIcon);
        MyIcon := LoadIcon (0, idi_Exclamation);
        DrawIcon (MyHDC, 170, 10, MyIcon);
        MyIcon := LoadIcon (0, idi_Hand);
        DrawIcon (MyHDC, 230, 10, MyIcon);
        MyIcon := LoadIcon (0, idi_Question);
        DrawIcon (MyHDC, 290, 10, MyIcon);
	EndPaint (MyHDC, PaintStruct);
    END;
    wm_Destroy:
      BEGIN
	PostQuitMessage(0);
	Exit;
      END;
  END;
  WindowProc := DefWindowProc(Window, Message, wParam, lParam);
END;

PROCEDURE WinMain;
VAR
  Window: hWND;
  Message: tMsg;
BEGIN
  IF HPrevInst = 0 THEN
  BEGIN
    WindowClass.hInstance := hInstance;
    WindowClass.hIcon := LoadIcon(hInstance, 'earth');
    WindowClass.hCursor := LoadCursor(0, idc_Arrow);
    WindowClass.hbrBackground := GetStockObject(White_Brush);
    IF NOT RegisterClass(WindowClass) THEN Halt(255);
  END;
  Window := CreateWindow(
    AppName,                  (* Window class name                    *)
    'Die vordefinierten Icons',   (* Window Caption			      *)
    ws_OverlappedWindow,      (* Window style			      *)
    cw_UseDefault,	      (* initial x position		      *)
    cw_UseDefault,	      (* initial y position		      *)
    cw_UseDefault,	      (* initial x size			      *)
    cw_UseDefault,	      (* initial y size			      *)
    0,			      (* parent window handle		      *)
    0,			      (* window menu handle		      *)
    hInstance,		      (* program instance handle	      *)
    NIL);		      (* creation parameters		      *)
  ShowWindow(Window, CmdShow);
  UpdateWindow(Window);
  WHILE GetMessage(Message, 0, 0, 0) DO
  BEGIN
    TranslateMessage(Message);
    DispatchMessage(Message);
  END;
  Halt(Message.wParam);
END;

BEGIN
  WinMain;
END.
